<?php
/*##################################################
 *                               admin_cache.php
 *                            -------------------
 *   begin                : June 20, 2005
 *   copyright            : (C) 2005 Viarre Rgis
 *   email                : crowkait@phpboost.com
 *
 *
 *
###################################################
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
###################################################
 * 2012-03-14  SaTurNin  <saturnin@chez-swan.net> 
 *   Ajout de la gestion du cache Tpl
 * 
 *  */


require_once('../admin/admin_begin.php');
define('TITLE', $LANG['administration']);
require_once('../admin/admin_header.php');

$cache_mode = retrieve(GET, 'cache', '');

if (empty($cache_mode))    // Gnration du cache de la configuration
{
    //Si c'est confirm on execute
    if (!empty($_POST['cache']))
    {
        $Cache->Generate_all_files();
        redirect(HOST . DIR . '/admin/admin_cache.php?s=1');
    }
    else //Sinon on rempli le formulaire
    {
        $Template->set_filenames(array(
            'admin_cache'=> 'admin/admin_cache.tpl'
        ));
        
        //Gestion erreur.
        $get_error = retrieve(GET, 's', 0);
        if ($get_error == 1)
            $Errorh->handler($LANG['cache_success'], E_USER_SUCCESS);
        
        $Template->assign_vars(array(
            'L_CACHE' => $LANG['cache'],
            'L_SYNDICATION' => $LANG['syndication'],
            'L_TEMPLATE' => 'Template',
            'L_EXPLAIN_SITE_CACHE' => $LANG['explain_site_cache'],
            'L_GENERATE' => $LANG['generate']
        ));
        
        $Template->pparse('admin_cache');
    }
}else if($cache_mode === 'syndication'){ //syndication
    //Si c'est confirm on execute
    if (!empty($_POST['cache']))
    {
        import('content/syndication/feed');
        Feed::clear_cache();
        
        redirect(HOST . DIR . '/admin/admin_cache.php?cache=syndication&s=1');
    }
    else //Sinon on rempli le formulaire
    {
        $Template->set_filenames(array(
            'admin_cache_syndication'=> 'admin/admin_cache_syndication.tpl'
        ));
        
        //Gestion erreur.
        $get_error = retrieve(GET, 's', 0);
        if ($get_error == 1)
        {
            $Errorh->handler($LANG['cache_success'], E_USER_SUCCESS);
        }
        
        $Template->assign_vars(array(
            'L_CACHE' => $LANG['cache'],
            'L_SYNDICATION' => $LANG['syndication'],
            'L_TEMPLATE' => 'Template',
            'L_EXPLAIN_SITE_CACHE' => $LANG['explain_site_cache_syndication'],
            'L_GENERATE' => $LANG['generate']
        ));
        
        $Template->pparse('admin_cache_syndication');
    }
}else if($cache_mode === 'template'){ // template

	function GetFileList( $dirname="." ) {   
		if (! is_dir($dirname)) { return false; } // not a dir
		$files = array(); 
		$dir = @opendir( $dirname ) ;
		while( $file = readdir( $dir ) ) {
			if (stristr($file, '.php') != FALSE){
				//if (preg_match('/download/',$file)){
					$files[] = $file; 
				//}
			}
		}
		sort($files);
	 	return $files;
	}
    //Si c'est confirm on execute
	if (!empty($_POST['cache'])) {

		$cache_path = '../cache/tpl/';
		$cachelist = GetFileList($cache_path);
		$nbr_tot = count($cachelist);
		if ($cachelist == false ){
			redirect(HOST . DIR . '/admin/admin_cache.php?cache=template&s=2'); // erreur
		}else{
			$debut	 = 0;
			$cache_dl = GetFileList($cache_path) ;
			for($i=$debut; $i < $nbr_tot ; $i++) { 
				if( (file_exists($cache_path."".$cache_dl[$i])) && ( !empty($_POST['cache']) )) {
					unlink($cache_path."".$cache_dl[$i]) ;
				}
			}
		}
			
		redirect(HOST . DIR . '/admin/admin_cache.php?cache=template&s=1');
	}else{ //Sinon on rempli le formulaire

        $Template->set_filenames(array(
            'admin_cache_template'=> 'admin/admin_cache_template.tpl'
        ));
        
        //Gestion erreur.
        $get_error = retrieve(GET, 's', 0);
        if ($get_error == 1) {
            $Errorh->handler($LANG['cache_success'], E_USER_SUCCESS);
        }
        if ($get_error == 2) {
            $Errorh->handler('Une erreur est survenu.<br /> le cache n\'a pas t rgnrer.', E_USER_WARNING);
        }
        
        $Template->assign_vars(array(
            'L_CACHE' => $LANG['cache'],
            'L_SYNDICATION' => $LANG['syndication'],
            'L_TEMPLATE' => 'Template',
            'L_EXPLAIN_SITE_CACHE' => $LANG['explain_site_cache_syndication'],
            'L_GENERATE' => $LANG['generate']
        ));
        
        $Template->pparse('admin_cache_template');
    }
}

require_once('../admin/admin_footer.php');

?>
